#include "entry.h"
#include <stdlib.h>
#include <string.h>

EntryType entry_type_from_char(char c) {
  switch (c) {
  case '0':
    return Redirect;
  case '1':
    return Paste;
  default:
    return Unknown;
  }
}

char entry_type_to_char(EntryType et) {
  switch (et) {
  case Redirect:
    return '0';
  case Paste:
    return '1';
  default:
    return '\0';
  }
}

uint64_t entry_new(Entry **entry_ptr, EntryType type, const char *string) {
  size_t str_len = strlen(string);
  uint64_t entry_size = sizeof(EntryType) + str_len + 1;
  Entry *entry = malloc(entry_size);
  entry->type = type;

  if (string != NULL) {
    memcpy(entry->string, string, str_len + 1);
  } else {
    entry->string[0] = '\0';
  }

  *entry_ptr = entry;
  return entry_size;
}

void entry_free(Entry *entry) { free(entry); }
